<template>
  <div>
    <h1>Panier</h1>

    <div v-if="cart">
      <div v-for="entree in myentree" :key="entree.id">
        {{ entree.quantity }} - {{ entree.name_dish }} -
        {{ entree.price_dish }} -
        {{ entree.quantity * entree.price_dish }}

        <b-icon
          @click="incrementQuantityEntree(entree)"
          class="mr-2"
          icon="plus-circle"
          font-scale="1.5"
        ></b-icon>
        <b-icon
          @click="decrementQuantityEntree(entree)"
          icon="x-circle"
          font-scale="1.5"
        ></b-icon>
      </div>
    </div>

    <div v-if="cart">
      <div v-for="plat in myplat" :key="plat.id">
        {{ plat.quantity }} - {{ plat.name_dish }} - {{ plat.price_dish }} -
        {{ plat.quantity * plat.price_dish }}
        <b-icon
          @click="incrementQuantityPlat(plat)"
          class="mr-2"
          icon="plus-circle"
          font-scale="1.5"
        ></b-icon>
        <b-icon
          @click="decrementQuantityPlat(plat)"
          icon="x-circle"
          font-scale="1.5"
        ></b-icon>
      </div>
      <div v-for="dessert in mydessert" :key="dessert.id">
        {{ dessert.quantity }} - {{ dessert.name_dish }} -
        {{ dessert.price_dish }} - {{ dessert.quantity * dessert.price_dish }}
        <b-icon
          @click="incrementQuantityDessert(dessert)"
          class="mr-2"
          icon="plus-circle"
          font-scale="1.5"
        ></b-icon>
        <b-icon
          @click="decrementQuantityDessert(dessert)"
          icon="x-circle"
          font-scale="1.5"
        ></b-icon>
      </div>
      <div v-for="boisson in myboisson" :key="boisson.id">
        {{ boisson.quantity }} - {{ boisson.name_dish }} -
        {{ boisson.price_dish }} - {{ boisson.quantity * boisson.price_dish }}
        <b-icon
          @click="incrementQuantityBoisson(boisson)"
          class="mr-2"
          icon="plus-circle"
          font-scale="1.5"
        ></b-icon>
        <b-icon
          @click="decrementQuantityBoisson(boisson)"
          icon="x-circle"
          font-scale="1.5"
        ></b-icon>
      </div>
      <div>
        Total :
        {{
          totalItemEntree + totalItemPlat + totalItemDessert + totalItemBoisson
        }}
      </div>
    </div>
    <div>
      <b-button
        @click="addToCommand"
        variant="outline-primary"
        class="m-2"
        href="#"
        >commander</b-button
      >
    </div>
  </div>
</template>

<script>
import axios from "axios";
export default {
  methods: {
    incrementQuantityEntree(entree) {
      this.$store.dispatch("updateCartEntree", entree);
    },
    decrementQuantityEntree(entree) {
      console.log(entree);
      this.$store.dispatch("deleteEntreeFromCart", entree);
    },
    incrementQuantityPlat(plat) {
      this.$store.dispatch("updateCartPlat", plat);
    },
    decrementQuantityPlat(plat) {
      this.$store.dispatch("deletePlatFromCart", plat);
    },
    incrementQuantityDessert(dessert) {
      this.$store.dispatch("updateCartDessert", dessert);
    },
    decrementQuantityDessert(dessert) {
      this.$store.dispatch("deleteDessertFromCart", dessert);
    },
    incrementQuantityBoisson(boisson) {
      this.$store.dispatch("updateCartBoisson", boisson);
    },
    decrementQuantityBoisson(boisson) {
      this.$store.dispatch("deleteBoissonFromCart", boisson);
    },
    addToCommand() {
    const headers = {
      "Content-Type": "application/json",
      Authorization: `Bearer ${this.token}`, //norme voir sur internet
    };
    axios
      .post(`http://localhost:8081/commands`, this.cart, {
        headers: headers,
      })
      .then((response) => {
        console.log(response);
      })
      .catch((e) => {
        console.log(e);
      });
  }
  },

  computed: {

    cart: function() {
      return this.$store.getters.getCart;
    },
    myentree: function() {
      return this.$store.getters.getEntrees;
    },
    myplat: function() {
      return this.$store.getters.getPlats;
    },
    mydessert: function() {
      return this.$store.getters.getDesserts;
    },
    myboisson: function() {
      return this.$store.getters.getBoissons;
    },
    token: function() {
      return this.$store.getters.getTokenAuthorisation;
    },

    totalItemEntree: function() {
      let sum = 0;
      if (this.cart.entrees) {
        this.cart.entrees.forEach(function(entree) {
          sum += parseFloat(entree.price_dish) * parseFloat(entree.quantity);
        });
      }
      return sum;
    },

    totalItemPlat: function() {
      let sum = 0;
      if (this.cart.plats) {
        this.cart.plats.forEach(function(plat) {
          sum += parseFloat(plat.price_dish) * parseFloat(plat.quantity);
        });
      }
      return sum;
    },
    totalItemDessert: function() {
      let sum = 0;
      if (this.cart.desserts) {
        this.cart.desserts.forEach(function(dessert) {
          sum += parseFloat(dessert.price_dish) * parseFloat(dessert.quantity);
        });
      }
      return sum;
    },
    totalItemBoisson: function() {
      let sum = 0;
      if (this.cart.boissons) {
        this.cart.boissons.forEach(function(boisson) {
          sum += parseFloat(boisson.price_dish) * parseFloat(boisson.quantity);
        });
      }
      return sum;
    },
  }
};
</script>

<style lang="scss" scoped></style>
